package com.americancoders.ebXML;

import java.util.Vector;


/**
 * ebXMLHeader Element The root element of the XML ebXML Header Document is named ebXMLHeader. It is comprised 513
 * of three XML attributes and two subordinate elements.
 * <br> package built from ebXML Messaging Service Specification
 * <br>ebXML Transport, Routing & Packaging
 * <br> Version 0.21d
 * <br> 16 October 2000
 * <br>Note this specification is in development and is subject to change
 *<p>ebXMLHeader attributes
 *<ul>There are three attributes associated with the ebXMLHeader, which are:
 *<li> Namespace (xmlns)
 *<li> Version
 *<li> MessageType
 *</ul>
 *<ul>The ebXMLHeader element MUST contain the following two elements:
 *<li> Manifest
 *<li> Header
 *</ul>
 *<br>
 *<b><i>This module, both source code and documentation, is in the Public
 * Domain, and comes with NO WARRANTY. </i></b>
 *Copyright (C) 2000 American Coders, Ltd. Raleigh NC USA
 *<br>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the Mozilla Public License
 * as published by the Mozilla Software Foundation
 * http://www.mozilla.org/MPL
 *<br>
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Mozilla Public License for more details.
 *<br>
 *@version 0.21d.001
 *@author Joe McVerry American Coders, Ltd.
 *@see http://www.ebxml.org
 */
public class  ebXMLHeader {


/**
 * test routine
 */
public static void main(String args[])
{
	ebXMLHeader ebXMLHeader = new ebXMLHeader();
	Manifest man = new Manifest();
	ebXMLHeader.setManifest(man);
	DocumentReference df = new DocumentReference();
	man.addDocumentReference(df);
    ValueType dd = new ValueType();
    df.addDocumentDescription(dd);
    ValueType dl = new ValueType();
    df.setDocumentLabel(dl);
    ValueType di = new ValueType();
    df.setDocumentId(di);
    Header head = new Header();
	ebXMLHeader.setHeader(head);
	From fr = new From();
	head.setFrom(fr);
	ValueTypeContext pid = new ValueTypeContext();
	fr.setPartyId(pid);
	To to = new To();
	head.setTo(to);
	to.setPartyId(pid);
	TPAInfo tpaInfo = new TPAInfo();
	ValueTypeContext TPAId = new ValueTypeContext();
	tpaInfo.setTPAId(TPAId);
	ValueTypeContext ConversationId = new ValueTypeContext();
	tpaInfo.setConversationId(ConversationId);
	ValueType ServiceInterface = new ValueType();
	tpaInfo.setServiceInterface(ServiceInterface);
	ValueType Action = new ValueType();
	tpaInfo.setAction(Action);
	head.setTPAInfo(tpaInfo);
	MessageData md = new MessageData();
	head.setMessageData(md);
	ValueType MessageId = new ValueType();
	md.setMessageId(MessageId);
	ValueType TimeStamp = new ValueType();
	md.setTimeStamp(TimeStamp);
	ValueType RefToMessageId = new ValueType();
	md.setRefToMessageId(RefToMessageId);
	ReliableMessagingInfo rmi = new ReliableMessagingInfo();
	head.setReliableMessagingInfo(rmi);
	RoutingHeader rtehead = new RoutingHeader();
	ebXMLHeader.setRoutingHeader(rtehead);
	ValueType SenderURI = new ValueType();
	rtehead.setSenderURI(SenderURI);
	ValueType ReceiverURI = new ValueType();
	rtehead.setReceiverURI(ReceiverURI);
	ValueType ErrorURI = new ValueType();
	rtehead.setErrorURI(ErrorURI);
	ValueType Timestamp = new ValueType();
	rtehead.setTimeStamp(Timestamp);
	String SequenceNumber = "0001";
	rtehead.setSequenceNumber(SequenceNumber);
    System.out.println("<?xml version =\"1.0\" encoding=\"UTF-8\"?>");
    System.out.println("<!DOCTYPE ebXMLHeader SYSTEM \"level1-10122000.dtd\">");
    //System.out.println("<ebXMLHeader  xmlns = \"http://www.ebxml.org/namespaces/messageHeader\"");
	System.out.println(ebXMLHeader.getXML());
}


private String version = "1.0";
private String messageType = "Normal";
private Manifest manifest = null;
private Header header = null;
private RoutingHeader routingHeader = null;

/** method to set Version
 * @param String inVersion
 */
public void setVersion(String inVersion) {version = inVersion;}

/** method to get Version
 * @return String
 */
public String getVersion() {return version;}
/** method to set MessageType
 * @param String inMessageType
 */
public void setMessageType(String inMessageType) {messageType = inMessageType;}

/** method to get MessageType
 * @return String
 */
public String getMessageType() {return messageType;}
/** method to set Manifest
 * @param Manifest inmanifest
 */
public void setManifest(Manifest inmanifest) {manifest = inmanifest;}

/** method to get Manifest
 * @return Manifest
 */
public Manifest getManifest() {return manifest;}
/** method to set Header
 * @param Header inHeader
 */
public void setHeader(Header inHeader) {header = inHeader;}

/** method to get Header
 * @return Header
 */
public Header getHeader() {return header;}
/** method to set RoutingHeader
 * @param RoutingHeader inRoutingHeader
 */
public void setRoutingHeader(RoutingHeader inRoutingHeader) {routingHeader = inRoutingHeader;}

/** method to get RoutingHeader
 * @return RoutingHeader
 */
public RoutingHeader getRoutingHeader() {return routingHeader;}


/**
 * method to build an XML string of this and its subordinate objects.
 * <br>
 * <i> the ebXMLHeader is the only getXML function you should have to call, it will
 * call its children's getXML methods for you.
 * </i>
 * @return String - XML text
 */
public String getXML() {
	StringBuffer sb = new StringBuffer();
	int depth = 0;
	sb.append(ebXMLHeader.addDepth(depth)+"<ebXMLHeader");
    sb.append(" xmlns=\"http://www.ebxml.org/namespaces/messageHeader\"");
	if (version != null)
    	sb.append(ebXMLHeader.addDepth(depth)+" Version=\""+version+"\"");

	if (messageType != null)
   	    sb.append(ebXMLHeader.addDepth(depth)+" MessageType=\""+messageType+"\"");

    sb.append(">\n");

	if (manifest == null)
	  System.err.println("manifest object for ebXMLHeader object not defined");
	else
	  sb.append(manifest.getXML(depth));

	if (header == null)
	  System.err.println("header object for ebXMLHeader object not defined");
	else
	  sb.append(header.getXML(depth));

	if (routingHeader == null)
	  System.err.println("routingHeader object for ebXMLHeader object not defined");
	else
	  sb.append(routingHeader.getXML(depth));

	sb.append(ebXMLHeader.addDepth(depth)+"</ebXMLHeader>");

	return new String(sb);

}

/** help routine to add mulitple of 4 spaces to outbound XML text
 * @param int depth multipler
 */
public static String addDepth(int depth)
  { StringBuffer sb = new StringBuffer();
    for (int i=0; i < depth; i++) sb.append("    ");
    return new String(sb);
  }

}

/**
 * The Manifest is a REQUIRED element that contains a list of references to he other parts of the Message. This includes references to the documents, which comprise the Payload of the
 * Message.
 */
class Manifest
{
private Vector documentReferences;
private DocumentReference documentReference;

/**
 * constructor, one of a few classes that has a constructor so that the
 * vector object to hold DocumentReferences can be instantiated
 */

public Manifest()
  {
	  documentReferences = new Vector();
  }

/**
 * method to add a DocumentReference object to Vector documentReferences
 * @param DocumentReference inDocumentReference
 */
public void addDocumentReference(DocumentReference inDocumentReference) {documentReferences.add(inDocumentReference);}

/**
 * method to return a Vector of DocumentReferences
 * @return Vector
 */
 public Vector getDocumentReferences() {return documentReferences;}


/** method to set DocumentReference
 * @param DocumentReference inDocumentReference
 */
public void setDocumentReference(DocumentReference inDocumentReference) {documentReference = inDocumentReference;}

/** method to get DocumentReference
 * @return DocumentReference
 */
public DocumentReference getDocumentReference() {return documentReference;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<Manifest>\n");
    for (int i=0; i<documentReferences.size();i++)
      {
		  documentReference = (DocumentReference) documentReferences.elementAt(i);
		  sb.append(documentReference.getXML(depth));
	  }
	sb.append(ebXMLHeader.addDepth(depth)+"</Manifest>\n");
	return new String(sb);
}

}

/**
 * a class for objects that contain simple values with an e-dtype attribute
 */
class ValueType {
private String value;
/** method to set Type
 * @param String inType
 */
public void setValue(String inValue) {value = inValue;}

/** method to get Value
 * @return String
 */
public String getValue() {return value;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth, String name){
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<"+name+">");
	if (getValue() == null)
        System.err.println(name + " is missing required value field");
    else
    	sb.append(getValue());
	sb.append("</"+name+">\n");
	return new String(sb);
}
}

/**
 * a class for objects that contain simple values and e-dtype and context attributes
 * <br>The purpose of the context attribute is to provide a context for the
 * text value of the PartyId element.
 */
class ValueTypeContext  extends ValueType
{
private String context = "Undefined";
/** method to set Context
 * @param String inContext
 */
public void setContext(String inContext) {context = inContext;}

/** method to get Context
 * @return String
 */
public String getContext() {return context;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth, String name){
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<"+name+"\n");
	if (getContext() != null)
    	sb.append(ebXMLHeader.addDepth(depth)+"   context=\""+getContext()+"\">");
	if (getValue() == null)
        System.err.println(name + " is missing required value field");
    else
    	sb.append(getValue());
	sb.append("</"+name+">\n");
	return new String(sb);
}
}

/**
 *The DocumentReference element is a composite element consisting of three subordinate elements as follows:
 *<ul>
 *<li> DocumentDescription
 *<li> DocumentLabel
 *<li> DocumentId
 *</ul>
 */
class DocumentReference {
private Vector documentDescriptions;
private ValueType documentDescription;
private ValueType documentLabel;
private ValueType documentId;

public DocumentReference()
  {
	  documentDescriptions = new Vector();
  }

public void addDocumentDescription(ValueType inDocumentDescription) {documentDescriptions.add(inDocumentDescription);}
public Vector getDocumentDescriptions() {return documentDescriptions;}
/** method to set DocumentLabel
 * @param ValueType inDocumentLabel
 */
public void setDocumentLabel(ValueType inDocumentLabel) {documentLabel = inDocumentLabel;}

/** method to get DocumentLabel
 * @return ValueType
 */
public ValueType getDocumentLabel() {return documentLabel;}
/** method to set DocumentId
 * @param ValueType inDocumentId
 */
public void setDocumentId(ValueType inDocumentId) {documentId = inDocumentId;}

/** method to get DocumentId
 * @return ValueType
 */
public ValueType getDocumentId() {return documentId;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<DocumentReference>\n");
    for (int i=0; i<documentDescriptions.size();i++)
      {
		  documentDescription= (ValueType) documentDescriptions.elementAt(i);
		  sb.append(documentDescription.getXML(depth, "DocumentDescription"));
	  }

	if (documentLabel == null)
	    System.err.println("documentLabel object for DocumentReference object not defined.");
	else
	    sb.append(documentLabel.getXML(depth, "DocumentLabel"));

	if (documentId == null)
	    System.err.println("documentId object for DocumentReference object not defined.");
	else
	    sb.append(documentId.getXML(depth, "DocumentId"));
	sb.append(ebXMLHeader.addDepth(depth)+"</DocumentReference>\n");
	return new String(sb);

}
}

/**
 * The Header element immediately follows the Manifest element. It is required in all ebXMLHeader documents. The Header element is a composite element comprised of the
 * following required subordinate elements:
 *<ul>
 *<li> From
 *<li> To
 *<li> TPAInfo
 *<li> MessageData
 *<li) ReliableMessagingInfo
 *</ul>
 */
class Header {
private From from;
private To to;
private TPAInfo tpaInfo;
private MessageData messageData;
private ReliableMessagingInfo reliableMessagingInfo;
/** method to set From
 * @param From inFrom
 */
public void setFrom(From inFrom) {from = inFrom;}

/** method to get From
 * @return From
 */
public From getFrom() {return from;}
/** method to set To
 * @param To inTo
 */
public void setTo(To inTo) {to = inTo;}

/** method to get To
 * @return To
 */
public To getTo() {return to;}
/** method to set TPAInfo
 * @param TPAInfo inTPAInfo
 */
public void setTPAInfo(TPAInfo inTPAInfo) {tpaInfo = inTPAInfo;}

/** method to get TPAInfo
 * @return TPAInfo
 */
public TPAInfo getTPAInfo() {return tpaInfo;}
/** method to set MessageData
 * @param MessageData inMessageData
 */
public void setMessageData(MessageData inMessageData) {messageData = inMessageData;}

/** method to get MessageData
 * @return MessageData
 */
public MessageData getMessageData() {return messageData;}
/** method to set ReliableMessagingInfo
 * @param ReliableMessagingInfo inReliableMessagingInfo
 */
public void setReliableMessagingInfo(ReliableMessagingInfo inReliableMessagingInfo) {reliableMessagingInfo = inReliableMessagingInfo;}

/** method to get ReliableMessagingInfo
 * @return ReliableMessagingInfo
 */
public ReliableMessagingInfo getReliableMessagingInfo() {return reliableMessagingInfo;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<Header>\n");
	if (from == null)
	  System.err.println("from object for header object not defined");
	else
	  sb.append(from.getXML(depth));

	if (to == null)
	  System.err.println("to object for header object not defined");
	else
	  sb.append(to.getXML(depth));

	if (tpaInfo == null)
	  System.err.println("tpaInfo object for header object not defined");
	else
	  sb.append(tpaInfo.getXML(depth));

	if (messageData == null)
	  System.err.println("messageData object for header object not defined");
	else
	  sb.append(messageData.getXML(depth));

	if (reliableMessagingInfo == null)
	  System.err.println("reliableMessagingInfo object for header object not defined");
	else
	  sb.append(reliableMessagingInfo.getXML(depth));

	sb.append(ebXMLHeader.addDepth(depth)+"</Header>\n");
	return new String(sb);

}
}

/**
 * The TPAInfo element follows the From and To elements in the Header element structure. The TPAInfo element is a composite set of information that relates to the Trading Partner Agreement
 * under which the message is governed. The TPAInfo element has four subordinate elements as
 * follows:
 * <ul>
 * <li> TPAId
 * <li> ConversationId
 * <li> ServiceInterface
 * <li> Action
 * </ul>
 */

class TPAInfo {
private ValueTypeContext tpaId;
private ValueTypeContext conversationId;
private ValueType serviceInterface;
private ValueType action;
/** method to set TPAId
 * @param ValueTypeContext inTPAId
 */
public void setTPAId(ValueTypeContext inTPAId) {tpaId = inTPAId;}

/** method to get TPAId
 * @return ValueTypeContext
 */
public ValueTypeContext getTPAId() {return tpaId;}

/** method to set ConversationId
 * @param ValueTypeContext inConversationId
 */
public void setConversationId(ValueTypeContext inConversationId) {conversationId = inConversationId;}

/** method to get ConversationId
 * @return ValueTypeContext
 */
public ValueTypeContext getConversationId() {return conversationId;}
/** method to set ServiceInterface
 * @param ValueType inServiceInterface
 */
public void setServiceInterface(ValueType inServiceInterface) {serviceInterface = inServiceInterface;}

/** method to get ServiceInterface
 * @return ValueType
 */
public ValueType getServiceInterface() {return serviceInterface;}
/** method to set Action
 * @param ValueType inAction
 */
public void setAction(ValueType inAction) {action = inAction;}

/** method to get Action
 * @return ValueType
 */
public ValueType getAction() {return action;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<TPAInfo>\n");
	if (tpaId == null)
	    System.err.println("TPAId object for TPAInfo object not defined.");
    else
	    sb.append(tpaId.getXML(depth, "TPAId"));
	if (conversationId == null)
	    System.err.println("conversationId object for TPAInfo object not defined.");
	else
	    sb.append(conversationId.getXML(depth, "ConversationId"));
	if (serviceInterface == null)
	    System.err.println("serviceInterface object for TPAInfo object not defined.");
	else
	    sb.append(serviceInterface.getXML(depth, "ServiceInterface"));
	if (action == null)
	    System.err.println("action object for TPAInfo object not defined.");
	else
	    sb.append(action.getXML(depth, "Action"));
	sb.append(ebXMLHeader.addDepth(depth)+"</TPAInfo>\n");
	return new String(sb);
}
}

/**
 * The required MessageData element follows the TPAInfo element. The purpose of the MessageData element is to provide a means of identifying an ebXML Message. It is a composite
 * element that contains the following three elements:
 * <li>
 * <li> MessageID
 * <li> TimeStamp
 * <li> RefToMessageID
 * <ul>
 */

class MessageData {
private ValueType timeStamp;
private ValueType messageId;
private ValueType refToMessageId;
/** method to set MessageId
 * @param ValueType inMessageId
 */
public void setMessageId(ValueType inMessageId) {messageId = inMessageId;}

/** method to get MessageId
 * @return ValueType
 */
public ValueType getMessageId() {return messageId;}
/** method to set TimeStamp
 * @param ValueType inTimeStamp
 */
public void setTimeStamp(ValueType inTimeStamp) {timeStamp = inTimeStamp;}

/** method to get TimeStamp
 * @return ValueType
 */
public ValueType getTimeStamp() {return timeStamp;}
/** method to set RefToMessageId
 * @param ValueType inRefToMessageId
 */
public void setRefToMessageId(ValueType inRefToMessageId) {refToMessageId = inRefToMessageId;}

/** method to get RefToMessageId
 * @return ValueType
 */
public ValueType getRefToMessageId() {return refToMessageId;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<MessageData>\n");
    if (messageId == null)
	    System.err.println("messageId object for MessageData object not defined.");
	else
	    sb.append(messageId.getXML(depth, "MessageId"));
	if (timeStamp == null)
	    System.err.println("timeStamp object for MessageData object not defined.");
	else
    	sb.append(timeStamp.getXML(depth, "TimeStamp"));
	if (refToMessageId == null)
	    System.err.println("refToMessageId object for MessageData object not defined.");
	else
	    sb.append(refToMessageId.getXML(depth, "RefToMessageId"));
	sb.append(ebXMLHeader.addDepth(depth)+"</MessageData>\n");
	return new String(sb);
}
}

/**
* The From element identifies the Party which originated the message. It is a logical identifier,
* which MAY take the form of a URN. An example of this would be a DUNS number. The From
* element consists of a PartyId element.
*/

class From{
	ValueTypeContext partyId;

/** method to set PartyId
 * The PartyId element has a single attribute; context and a text value. The purpose of the context attribute is to provide a context for the text value of the PartyId element. The following fragment
 * demonstrates usage of the From and To elements of the ebXMLHeader.
 * @param ValueTypeContext inPartyId
 */
public void setPartyId(ValueTypeContext inPartyId) {partyId  = inPartyId ;}

/** method to get PartyId
 * @return ValueTypeContext
 */
public ValueTypeContext getPartyId() {return partyId ;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<From>\n");
	if (partyId == null)
	    System.err.println("partyId object for From object not defined.");
	else
	    sb.append(partyId.getXML(depth, "PartyId"));
	sb.append(ebXMLHeader.addDepth(depth)+"</From>\n");
	return new String(sb);
}
}

/**
 * The To element identifies the intended recipient of the message. As with From, it is a logical identifier which is comprised of a PartyId element.
 */

class To{
ValueTypeContext partyId;
/** method to set PartyId
 * The PartyId element has a single attribute; context and a text value. The purpose of the context attribute is to provide a context for the text value of the PartyId element. The following fragment
 * demonstrates usage of the From and To elements of the ebXMLHeader.
 * @param ValueTypeContext inPartyId
 */
public void setPartyId(ValueTypeContext inPartyId) {partyId  = inPartyId ;}

/** method to get PartyId
 * @return ValueTypeContext
 */
public ValueTypeContext getPartyId() {return partyId ;}

/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<To>\n");
	if (partyId == null)
	    System.err.println("partyId object for To object not defined.");
	else
	    sb.append(partyId.getXML(depth, "PartyId"));
	sb.append(ebXMLHeader.addDepth(depth)+"</To>\n");
	return new String(sb);
}
}

/**
 * The last element of the ebXMLHeader is the ReliableMessagingInfo element. This element identifies the degree of reliability with which the message will be delivered. This element has a
 * single attribute, DeliverySemantics. This attribute is an enumeration, which may have one of the
 * following values:
 * <br> "OnceAndOnlyOnce" reliable messaging semantics: the receiving Service Interface
 * handler will receive a given message no more than once, the sending Messaging Service
 * will execute retry procedures in the event of failure and the sending Service Interface
 * handler will be notified in the event of failure.
 * <br> "BestEffort" reliable delivery semantics are not specified: the Sending Service Interface
 * handler is not notified of failure to deliver the message, duplicate messages might be
 * delivered and persistent storages are not required.
 */

class ReliableMessagingInfo {
private String deliverySemantics = "BestEffort";

/** method to set DeliverySemantics
 * @param String inDeliverySemantics
 */
public void setDeliverySemantics(String inDeliverySemantics) {deliverySemantics = inDeliverySemantics;}

/** method to set DeliverySemantics to OnceAndOnlyOnce
 */
public void setDeliverySemanticsToOnceAndOnlyOnce() {deliverySemantics = "OnceAndOnlyOnce";}

/** method to set DeliverySemantics to BestEffort
 */
public void setDeliverySemanticsToBestEffort() {deliverySemantics = "BestEffort";}

/** method to get DeliverySemantics
 * @return String
 */

public String getDeliverySemantics() {return deliverySemantics;}

/** return true if DeliverySemantics set to OnceAndOnlyOnce
 */
public boolean isOnceAndOnlyOnce() {return (deliverySemantics.compareTo("OnceAndOnlyOnce") == 0);}

/** returns true if DeliverySemantics set to BestEffort
 */
public boolean isBestEffort() {return (deliverySemantics.compareTo("BestEffort") == 0);}

/** method to get DeliverySemantics
 * @return String
 */
/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<ReliableMessagingInfo DeliverySemantics=\""+getDeliverySemantics()+"\"/>\n");
    return new String(sb);
}
}

/**
 *One RoutingHeader element immediately follows the Header element. It is required in all ebXMLHeader documents. The RoutingHeader element is a composite element comprised of at
 * least the following four required subordinate elements:
 * <ul>
 * <li> SenderURI  the Senders Messaging Service Handler URI.
 * <li> ReceiverURI the Receivers Messaging Service Handler URI.
 * <li> ErrorURI  URI designated by the Sender for reporting errors.
 * <li> Timestamp  timestamp of the RoutingHeader creation, in the same format used for
 * Timestamp in the XML Header MessageData element.
 * </ul>
*/
class RoutingHeader {
private ValueType senderURI;
private ValueType receiverURI;
private ValueType errorURI;
private ValueType timeStamp;
private String sequenceNumber;
/** method to set SenderURI
 * @param ValueType inSenderURI
 */
public void setSenderURI(ValueType inSenderURI){senderURI = inSenderURI;}

/** method to get SenderURI
 * @return ValueType
 */
public ValueType getSenderURI() {return senderURI;}
/** method to set ReceiverURI
 * @param ValueType inReceiverURI
 */
public void setReceiverURI(ValueType inReceiverURI){receiverURI = inReceiverURI;}

/** method to get ReceiverURI
 * @return ValueType
 */
public ValueType getReceiverURI() {return receiverURI;}
/** method to set ErrorURI
 * @param ValueType inErrorURI
 */
public void setErrorURI(ValueType inErrorURI){errorURI = inErrorURI;}

/** method to get ErrorURI
 * @return ValueType
 */
public ValueType getErrorURI() {return errorURI;}
/** method to set TimeStamp
 * @param ValueType inTimeStamp
 */
public void setTimeStamp(ValueType inTimeStamp){timeStamp = inTimeStamp;}

/** method to get TimeStamp
 * @return ValueType
 */
public ValueType getTimeStamp() {return timeStamp;}
/** method to set SequenceNumber
 * @param String inSequenceNumber
 */
public void setSequenceNumber(String inSequenceNumber){sequenceNumber = inSequenceNumber;}

/** method to get SequenceNumber
*/
public String getSequenceNumber() {return sequenceNumber;}


/**
 * method to build an XML string of this and its subordinate objects
 * @param int depth - how many multiple of 4 spaces to add in front of text
 * @return String - XML text
 */
public String getXML(int depth) {
	StringBuffer sb = new StringBuffer();
	depth++;
	sb.append(ebXMLHeader.addDepth(depth)+"<RoutingHeader>\n");
	if (senderURI == null)
	    System.err.println("senderURI object for RoutingHeader object not defined.");
	else
       sb.append(senderURI.getXML(depth, "SenderURI"));

    if (receiverURI == null)
	    System.err.println("receiverURI object for RoutingHeader object not defined.");
	else
       sb.append(receiverURI.getXML(depth, "ReceiverURI"));

    if (errorURI == null)
	    System.err.println("errorURI object for RoutingHeader object not defined.");
    else
       sb.append(errorURI.getXML(depth, "ErrorURI"));

    if (timeStamp == null)
	    System.err.println("timeStamp object for RoutingHeader object not defined.");
    else
       sb.append(timeStamp.getXML(depth, "TimeStamp"));

    if (getSequenceNumber() == null)
	    System.err.println("sequenceNumber object for RoutingHeader object not defined.");
    else
      sb.append(ebXMLHeader.addDepth(depth+1)+"<SequenceNumber>"+getSequenceNumber()+"</SequenceNumber>\n");

	sb.append(ebXMLHeader.addDepth(depth)+"</RoutingHeader>\n");
	return new String(sb);
}
}
